#include <stdio.h>
extern "C" {
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmain.h"
#include "gpfont.h"

#include "gpstdio.h"
#include "gpmem.h"
#include "gpmm.h"
}

#include "gfx.h"
#include "sdsfonts.h"
#include "neopop.h"

GPDRAWSURFACE gpDraw[2];
int nflip;
unsigned short int *map;
char trom[1024*1024*4];
GPDIRENTRY MDL[100];
ulong DIRCOUNT;
int MenuSelection;
int Menucyp;
int Menucyi;

int QUIT;


_u8 system_frameskip_key;

	void system_sound_chipreset(void)
	{
	}

	
	void system_sound_silence(void)
	{
	}


BOOL system_io_state_read(char* filename, _u8* buffer, _u32 bufferLength)
{
}
BOOL system_io_state_write(char* filename, _u8* buffer, _u32 bufferLength)
{
}


void system_message(char* vaMessage,...)
{
}

char* system_get_string(STRINGS string_id)
{
}

BOOL system_io_flash_read(_u8* buffer, _u32 bufferLength)
{
}
BOOL system_io_flash_write(_u8* buffer, _u32 bufferLength)
{
}

BOOL system_comms_read(_u8* buffer)
{
}
BOOL system_comms_poll(_u8* buffer)
{
}
void system_comms_write(_u8 data)
{
}


void system_sound_clear(void)
{
}

BOOL system_io_rom_read(char* filename, _u8* buffer, _u32 bufferLength)
{
return TRUE;
}

static BOOL LoadRomFile(char* filename)
{
F_HANDLE fh;
ulong RCOUNT;
ulong FSize;

GpFileGetSize(filename, &FSize);
rom.length=FSize;
GpFileOpen(filename,OPEN_R,&fh);
rom.data=(unsigned char*)trom;
GpFileRead(fh,rom.data,FSize,&RCOUNT);
GpFileClose(fh);
}

static _u8 up,down,left,right,button_a,button_b,option;




void DoKeys()
{

up = down = left = right = button_a = button_b = option = 0;

int	key=GpKeyGet();


if (key & GPC_VK_UP) up=1;
if (key & GPC_VK_DOWN) down=1;
if (key & GPC_VK_LEFT) left=1;
if (key & GPC_VK_RIGHT) right=1;
if (key & GPC_VK_SELECT) option=1;
if (key & GPC_VK_FA) button_a=1;
if (key & GPC_VK_FB) button_b=1;


if ((key & GPC_VK_FL) && (key & GPC_VK_FR)) QUIT=1;


	ram[0x6F82] = up | (down << 1) | (left << 2) | (right << 3) |
		(button_a << 4) | (button_b << 5) | (option << 6);
}
char temp[256];
void DoGFX()
{
unsigned short int *row = (unsigned short int*)cfb;

_u16 r,g,b;
_u16 r16,g16,b16, *frame16;

int cx,cy;
		for (int y = 0; y < SCREEN_HEIGHT; y++)
		{
		cx=80*240;
		cy=(152-y)+44;
		cx+=cy;
			for (int x = 0; x < SCREEN_WIDTH; x++)
			{
				r = ((row[x] & 0x00F) << 1);
 				g = ((row[x] & 0x0F0)>>4)<<1;
 				b = ((row[x] & 0xF00) >> 8)<<1;
                map[cx]=(b<<1)+(g<<6)+(r<<11);
			cx+=240;                               
			}
			row += SCREEN_WIDTH;
		}
		static int framecount=0;
sprintf(temp,"Frame %d",framecount++);
TextOut((char*)map,32,8, (char*)temp, 0xffff,31<<11);

}

int t1,t2,t3,t4;

void system_VBL(void)
{
DoGFX();
}


void DebounceKey()
{
char key;
key=GpKeyGet();
while (key!=0)
key=GpKeyGet();
}

int DoLoader()
{
char key;
int color;
int i,l,m,n;
int tc;



while (1)
	{
	
		map=(unsigned short *)gpDraw[nflip++].ptbuffer;
        nflip %= 2;		
        GpSurfaceSet(&gpDraw[nflip]);



	for (l=0;l<320*240;l++)
		map[l]=0xffff;
	for (m=0;m<BMH;m++)
		for (l=0;l<320;l++)
		map[(240+BMH-(m+117))+(l*240)]=31<<1;


	if (DIRCOUNT>2)
	for (i=0;i<DIRCOUNT-2;i++)
		{
		if (((i*BMH)-(Menucyp/BMH)+115+BMH>0) && (239-((i*BMH)-(Menucyp/BMH)+115)<(240-BMH)))
			{
		if (i==MenuSelection-2)
			TextOut((char*)map,86, 239-((i*BMH)-(Menucyp/BMH)+115), (char*)&MDL[i+2].name, 0,31<<11);
			else
			TextOut((char*)map,86, 239-((i*BMH)-(Menucyp/BMH)+115), (char*)&MDL[i+2].name, 0,31<<6);
			}

		}

	//TextOut((char*)map, 0, 239-(BMH), (char*)"   SNES9X  V0.00 ", 0,31<<1);
	//TextOut((char*)map, 0, 239-(BMH*2), (char*)"  ZardozJones@Hotmail.com", 0,31<<1);


	key=GpKeyGet();
  	if (!(key & GPC_VK_UP) && !(key & GPC_VK_DOWN))
		{
		Menucyi=0;
		Menucyp=(Menucyp+(BMH/2))/(BMH);
		Menucyp=(Menucyp)*(BMH);
		}

        if (key & GPC_VK_DOWN)
		{
		if (Menucyi==0)
			Menucyp+=BMH*BMH;
		Menucyi+=2;
		if (Menucyi>128)
			Menucyi=128;
		}
        if (key & GPC_VK_UP)
		{
		if (Menucyi==0)
			Menucyp-=BMH*BMH;
		Menucyi-=2;
		if (Menucyi<-128)
			Menucyi=-128;
		}
	Menucyp=Menucyp+Menucyi;
	if (Menucyp<0) 
		Menucyp=0;
	if (Menucyp>=((DIRCOUNT-3)*BMH*BMH))
		Menucyp=(DIRCOUNT-3)*BMH*BMH;

	MenuSelection=(Menucyp/(BMH*BMH))+2;

	if (MenuSelection<2)
		MenuSelection=2;
	if (MenuSelection>=DIRCOUNT)
		MenuSelection=DIRCOUNT-1;

        if (key & GPC_VK_FA) 
		{DebounceKey();
		return MenuSelection;
		}
	
        if (key & GPC_VK_FB) 
		{DebounceKey();
		return MenuSelection;

		}
        if (key & GPC_VK_SELECT)   
		{DebounceKey();
		return MenuSelection;
		}

	tc++;
	}
}

void UpdateScreen(void)
{
//DoGFX();
}

void MainLoop()
{

char temp[256];
bios_install();
rom_loaded();
system_colour=COLOURMODE_AUTO;
system_frameskip_key=7;
reset();

QUIT=0;
while (QUIT==0)
        {
        //t1=GpTickCountGet()/4;
        for (int z=0;z<256;z++)
       		emulate();
        	
		//t2=GpTickCountGet()/4;        	
		//t3=GpTickCountGet()/4;        			
        DoKeys();
        //DoGFX();
		//t4=GpTickCountGet()/4;        
        
		//sprintf(temp,"Cpu %d GFX %d blit %d",t2-t1,t3-t2,t4-t3);
		//TextOut((char*)map,32,8, (char*)temp, 0xffff,31<<11);
        }

}

void ClearScreen(int col)
{
	nflip = 0;
	map=(unsigned short int *)gpDraw[nflip].ptbuffer;
	for (int a=0;a<320*240;a++)
	map[a]=col;
	nflip = 1;
	map=(unsigned short int *)gpDraw[nflip].ptbuffer;
	for (int a=0;a<320*240;a++)
	map[a]=col;

}

void Debugger(char *xx,int x,int y)
{
return;
char temp[256];
ClearScreen(0);
GpSurfaceSet(&gpDraw[0]);
map=(unsigned short int *)gpDraw[0].ptbuffer;
sprintf(temp,"%s %d",xx,x);
TextOut((char*)map,40,100, (char*)temp, 0xffff,31<<11);
if (y==1)
	{
	while(GpKeyGet()!=GPC_VK_FA)
	{
	};

	while(GpKeyGet()==GPC_VK_FA)
	{
	};
	}
}

void GpMain(void *arg)
{
int i;
GpClockSpeedChange (  132000000 , 0x3a011, 2);
//GpClockSpeedChange (  80000000 , 0x48012, 2);
GpGraphicModeSet(16,NULL);
GpFatInit();
GpKeyInit();
int loadthis;
i = GpLcdSurfaceGet(&gpDraw[0], 0);   
i = GpLcdSurfaceGet(&gpDraw[1], 1);  
GpSurfaceSet(&gpDraw[0]);
	
nflip = 0;
map=(unsigned short *)gpDraw[nflip].ptbuffer;

 

	//GpRelativePathSet("gp:\\gpmm\\neogeopc\\"); 
GpRelativePathSet("gp:\\gpmm\\neogeopc\\"); 
GpDirEnumList("gp:\\gpmm\\neogeopc\\",0,100,(GPDIRENTRY*)&MDL[0],&DIRCOUNT);


	MenuSelection=2;
	Menucyi=0;
	Menucyp=0;
	

while(1)
	{
	GpSurfaceSet(&gpDraw[0]);
	nflip = 0;	
	ClearScreen(0xffff);
	loadthis=DoLoader();	
	LoadRomFile((char*)&MDL[loadthis].name);
	ClearScreen(0);	
	GpSurfaceSet(&gpDraw[0]);
	nflip = 0;	
	map=(unsigned short *)gpDraw[0].ptbuffer;
	MainLoop();
	}
}
